Code

5c7c4a69019ec866fc2dd4e38b9523aa7e4f20df
[git.git] / git-rebase.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano.
4 #
6 USAGE='[-v] [--onto <newbase>] <upstream> [<branch>]'
7 LONG_USAGE='git-rebase replaces <branch> with a new branch of the
8 same name.  When the --onto option is provided the new branch starts
9 out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
10 It then attempts to create a new commit for each commit from the original
11 <branch> that does not exist in the <upstream> branch.
13 It is possible that a merge failure will prevent this process from being
14 completely automatic.  You will have to resolve any such merge failure
15 and run git rebase --continue.  Another option is to bypass the commit
16 that caused the merge failure with git rebase --skip.  To restore the
17 original <branch> and remove the .dotest working files, use the command
18 git rebase --abort instead.
20 Note that if <branch> is not specified on the command line, the
21 currently checked out branch is used.  You must be in the top
22 directory of your project to start (or continue) a rebase.
24 Example:       git-rebase master~1 topic
26         A---B---C topic                   A'\''--B'\''--C'\'' topic
27        /                   -->           /
28   D---E---F---G master          D---E---F---G master
29 '
30 . git-sh-setup
31 set_reflog_action rebase
33 RESOLVEMSG="
34 When you have resolved this problem run \"git rebase --continue\".
35 If you would prefer to skip this patch, instead run \"git rebase --skip\".
36 To restore the original branch and stop rebasing run \"git rebase --abort\".
37 "
38 unset newbase
39 strategy=recursive
40 do_merge=
41 dotest=$GIT_DIR/.dotest-merge
42 prec=4
43 verbose=
45 continue_merge () {
46         test -n "$prev_head" || die "prev_head must be defined"
47         test -d "$dotest" || die "$dotest directory does not exist"
49         unmerged=$(git-ls-files -u)
50         if test -n "$unmerged"
51         then
52                 echo "You still have unmerged paths in your index"
53                 echo "did you forget update-index?"
54                 die "$RESOLVEMSG"
55         fi
57         if test -n "`git-diff-index HEAD`"
58         then
59                 if ! git-commit -C "`cat $dotest/current`"
60                 then
61                         echo "Commit failed, please do not call \"git commit\""
62                         echo "directly, but instead do one of the following: "
63                         die "$RESOLVEMSG"
64                 fi
65                 printf "Committed: %0${prec}d" $msgnum
66         else
67                 printf "Already applied: %0${prec}d" $msgnum
68         fi
69         echo ' '`git-rev-list --pretty=oneline -1 HEAD | \
70                                 sed 's/^[a-f0-9]\+ //'`
72         prev_head=`git-rev-parse HEAD^0`
73         # save the resulting commit so we can read-tree on it later
74         echo "$prev_head" > "$dotest/prev_head"
76         # onto the next patch:
77         msgnum=$(($msgnum + 1))
78         echo "$msgnum" >"$dotest/msgnum"
79 }
81 call_merge () {
82         cmt="$(cat $dotest/cmt.$1)"
83         echo "$cmt" > "$dotest/current"
84         git-merge-$strategy "$cmt^" -- HEAD "$cmt"
85         rv=$?
86         case "$rv" in
87         0)
88                 return
89                 ;;
90         1)
91                 test -d "$GIT_DIR/rr-cache" && git-rerere
92                 die "$RESOLVEMSG"
93                 ;;
94         2)
95                 echo "Strategy: $rv $strategy failed, try another" 1>&2
96                 die "$RESOLVEMSG"
97                 ;;
98         *)
99                 die "Unknown exit code ($rv) from command:" \
100                         "git-merge-$strategy $cmt^ -- HEAD $cmt"
101                 ;;
102         esac
105 finish_rb_merge () {
106         rm -r "$dotest"
107         echo "All done."
110 while case "$#" in 0) break ;; esac
111 do
112         case "$1" in
113         --continue)
114                 diff=$(git-diff-files)
115                 case "$diff" in
116                 ?*)     echo "You must edit all merge conflicts and then"
117                         echo "mark them as resolved using git update-index"
118                         exit 1
119                         ;;
120                 esac
121                 if test -d "$dotest"
122                 then
123                         prev_head="`cat $dotest/prev_head`"
124                         end="`cat $dotest/end`"
125                         msgnum="`cat $dotest/msgnum`"
126                         onto="`cat $dotest/onto`"
127                         continue_merge
128                         while test "$msgnum" -le "$end"
129                         do
130                                 call_merge "$msgnum"
131                                 continue_merge
132                         done
133                         finish_rb_merge
134                         exit
135                 fi
136                 git am --resolved --3way --resolvemsg="$RESOLVEMSG"
137                 exit
138                 ;;
139         --skip)
140                 if test -d "$dotest"
141                 then
142                         if test -d "$GIT_DIR/rr-cache"
143                         then
144                                 git-rerere clear
145                         fi
146                         prev_head="`cat $dotest/prev_head`"
147                         end="`cat $dotest/end`"
148                         msgnum="`cat $dotest/msgnum`"
149                         msgnum=$(($msgnum + 1))
150                         onto="`cat $dotest/onto`"
151                         while test "$msgnum" -le "$end"
152                         do
153                                 call_merge "$msgnum"
154                                 continue_merge
155                         done
156                         finish_rb_merge
157                         exit
158                 fi
159                 git am -3 --skip --resolvemsg="$RESOLVEMSG"
160                 exit
161                 ;;
162         --abort)
163                 if test -d "$GIT_DIR/rr-cache"
164                 then
165                         git-rerere clear
166                 fi
167                 if test -d "$dotest"
168                 then
169                         rm -r "$dotest"
170                 elif test -d .dotest
171                 then
172                         rm -r .dotest
173                 else
174                         die "No rebase in progress?"
175                 fi
176                 git reset --hard ORIG_HEAD
177                 exit
178                 ;;
179         --onto)
180                 test 2 -le "$#" || usage
181                 newbase="$2"
182                 shift
183                 ;;
184         -M|-m|--m|--me|--mer|--merg|--merge)
185                 do_merge=t
186                 ;;
187         -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
188                 --strateg=*|--strategy=*|\
189         -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
190                 case "$#,$1" in
191                 *,*=*)
192                         strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
193                 1,*)
194                         usage ;;
195                 *)
196                         strategy="$2"
197                         shift ;;
198                 esac
199                 do_merge=t
200                 ;;
201         -v|--verbose)
202                 verbose=t
203                 ;;
204         -*)
205                 usage
206                 ;;
207         *)
208                 break
209                 ;;
210         esac
211         shift
212 done
214 # Make sure we do not have .dotest
215 if test -z "$do_merge"
216 then
217         if mkdir .dotest
218         then
219                 rmdir .dotest
220         else
221                 echo >&2 '
222 It seems that I cannot create a .dotest directory, and I wonder if you
223 are in the middle of patch application or another rebase.  If that is not
224 the case, please rm -fr .dotest and run me again.  I am stopping in case
225 you still have something valuable there.'
226                 exit 1
227         fi
228 else
229         if test -d "$dotest"
230         then
231                 die "previous dotest directory $dotest still exists." \
232                         'try git-rebase < --continue | --abort >'
233         fi
234 fi
236 # The tree must be really really clean.
237 git-update-index --refresh || exit
238 diff=$(git-diff-index --cached --name-status -r HEAD)
239 case "$diff" in
240 ?*)     echo "$diff"
241         exit 1
242         ;;
243 esac
245 # The upstream head must be given.  Make sure it is valid.
246 upstream_name="$1"
247 upstream=`git rev-parse --verify "${upstream_name}^0"` ||
248     die "invalid upstream $upstream_name"
250 # If a hook exists, give it a chance to interrupt
251 if test -x "$GIT_DIR/hooks/pre-rebase"
252 then
253         "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} || {
254                 echo >&2 "The pre-rebase hook refused to rebase."
255                 exit 1
256         }
257 fi
259 # If the branch to rebase is given, first switch to it.
260 case "$#" in
261 2)
262         branch_name="$2"
263         git-checkout "$2" || usage
264         ;;
265 *)
266         branch_name=`git symbolic-ref HEAD` || die "No current branch"
267         branch_name=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
268         ;;
269 esac
270 branch=$(git-rev-parse --verify "${branch_name}^0") || exit
272 # Make sure the branch to rebase onto is valid.
273 onto_name=${newbase-"$upstream_name"}
274 onto=$(git-rev-parse --verify "${onto_name}^0") || exit
276 # Now we are rebasing commits $upstream..$branch on top of $onto
278 # Check if we are already based on $onto, but this should be
279 # done only when upstream and onto are the same.
280 mb=$(git-merge-base "$onto" "$branch")
281 if test "$upstream" = "$onto" && test "$mb" = "$onto"
282 then
283         echo >&2 "Current branch $branch_name is up to date."
284         exit 0
285 fi
287 if test -n "$verbose"
288 then
289         echo "Changes from $mb to $onto:"
290         git-diff-tree --stat --summary "$mb" "$onto"
291 fi
293 # Rewind the head to "$onto"; this saves our current head in ORIG_HEAD.
294 echo "First, rewinding head to replay your work on top of it..."
295 git-reset --hard "$onto"
297 # If the $onto is a proper descendant of the tip of the branch, then
298 # we just fast forwarded.
299 if test "$mb" = "$branch"
300 then
301         echo >&2 "Fast-forwarded $branch_name to $onto_name."
302         exit 0
303 fi
305 if test -z "$do_merge"
306 then
307         git-format-patch -k --stdout --full-index --ignore-if-in-upstream "$upstream"..ORIG_HEAD |
308         git am --binary -3 -k --resolvemsg="$RESOLVEMSG"
309         exit $?
310 fi
312 # start doing a rebase with git-merge
313 # this is rename-aware if the recursive (default) strategy is used
315 mkdir -p "$dotest"
316 echo "$onto" > "$dotest/onto"
317 prev_head=`git-rev-parse HEAD^0`
318 echo "$prev_head" > "$dotest/prev_head"
320 msgnum=0
321 for cmt in `git-rev-list --no-merges "$upstream"..ORIG_HEAD \
322                         | @@PERL@@ -e 'print reverse <>'`
323 do
324         msgnum=$(($msgnum + 1))
325         echo "$cmt" > "$dotest/cmt.$msgnum"
326 done
328 echo 1 >"$dotest/msgnum"
329 echo $msgnum >"$dotest/end"
331 end=$msgnum
332 msgnum=1
334 while test "$msgnum" -le "$end"
335 do
336         call_merge "$msgnum"
337         continue_merge
338 done
340 finish_rb_merge